options nocenter validvarname=any;

*---Read in space-delimited ascii file;

data new_data;


infile 'social.dat' lrecl=113 missover DSD DLM=' ' print;
input
  R0000100
  R0153000
  R0153100
  R0153200
  R0153300
  R0153400
  R0153500
  R0153600
  R0153700
  R0153710
  R0173600
  R0214700
  R0214800
  R0303500
  R0303600
  R0303700
  R0303800
  R0303900
  R0304000
  R0304100
  R0304200
  R0304300
  R0304400
  R0304410
  R2349100
  R2349200
  R2349300
  R2349400
  R2349500
  R2349600
  R2349700
  R2349800
  R2349900
  R2350000
  R2350010
  T0899810
;
array nvarlist _numeric_;


*---Recode missing values to SAS custom system missing. See SAS
      documentation for use of MISSING option in procedures, e.g. PROC FREQ;

do over nvarlist;
  if nvarlist = -1 then nvarlist = .R;  /* Refused */
  if nvarlist = -2 then nvarlist = .D;  /* Dont know */
  if nvarlist = -3 then nvarlist = .I;  /* Invalid missing */
  if nvarlist = -4 then nvarlist = .V;  /* Valid missing */
  if nvarlist = -5 then nvarlist = .N;  /* Non-interview */
end;

  label R0000100 = "ID# (1-12686) 79";
  label R0153000 = "ROTTER SCALE - PAIR ONE, STMT A 79";
  label R0153100 = "ROTTER SCALE - PAIR ONE, STMT B 79";
  label R0153200 = "ROTTER SCALE - PAIR TWO, STMT A 79";
  label R0153300 = "ROTTER SCALE - PAIR TWO, STMT B 79";
  label R0153400 = "ROTTER SCALE - PAIR THREE, STMT A 79";
  label R0153500 = "ROTTER SCALE - PAIR THREE, STMT B 79";
  label R0153600 = "ROTTER SCALE - PAIR FOUR, STMT A 79";
  label R0153700 = "ROTTER SCALE - PAIR FOUR, STMT B 79";
  label R0153710 = "ROTTER SCALE SCORE 79";
  label R0173600 = "SAMPLE ID  79 INT";
  label R0214700 = "RACL/ETHNIC COHORT /SCRNR 79";
  label R0214800 = "SEX OF R 79";
  label R0303500 = "SELF ESTEEM AM A PERSON OF WORTH 80";
  label R0303600 = "SELF ESTEEM HAVE #GOOD QUALITIES 80";
  label R0303700 = "SELF ESTEEM INCL FEEL AM FAILURE 80";
  label R0303800 = "SELF ESTEEM AS CAPABLE AS OTHERS 80";
  label R0303900 = "SELF ESTEEM FEEL NOT MUCH PROUD 80";
  label R0304000 = "SELF ESTEEM HAVE POSITIVE ATTITUDE 80";
  label R0304100 = "SELF ESTEEM SATISFIED W/MYSELF 80";
  label R0304200 = "SELF ESTEEM WISH > SELF-RESPECT 80";
  label R0304300 = "SELF ESTEEM FEEL USELESS @ TIMES 80";
  label R0304400 = "SELF ESTEEM THINK NO GOOD @ ALL 80";
  label R0304410 = "SELF ESTEEM SCORE 80";
  label R2349100 = "SELF-ESTEEM I AM A PERSON OF WORTH 87";
  label R2349200 = "SELF-ESTEEM I HAVE A # GOOD QUALITY 87";
  label R2349300 = "SELF-ESTEEM FEEL THAT I AM FAILURE 87";
  label R2349400 = "SELF-ESTEEM I AM AS CAPABLE AS OTHR 87";
  label R2349500 = "SELF-ESTEEM DO NOT MUCH TO BE PROUD 87";
  label R2349600 = "SELF-ESTEEM I HAVE A POSITIVE ATND 87";
  label R2349700 = "SELF-ESTEEM I AM SATISFIED W/MYSELF 87";
  label R2349800 = "SELF-ESTEEM WISH MORE SELF-RESPECT 87";
  label R2349900 = "SELF-ESTEEM I FEEL USELESS @ TIMES 87";
  label R2350000 = "SELF-ESTEEM THINK NO GOOD @ ALL 87";
  label R2350010 = "SELF-ESTEEM SCORE 87";
  label T0899810 = "SELF-ESTEEM SCORE 06 2006";

/*---------------------------------------------------------------------*
 *  Crosswalk for Reference number & Question name                     *
 *---------------------------------------------------------------------*
 * Uncomment and edit this RENAME statement to rename variables
 * for ease of use.  You may need to use  name literal strings
 * e.g.  'variable-name'n   to create valid SAS variable names, or 
 * alter variables similarly named across years.
 * This command does not guarantee uniqueness

 * See SAS documentation for use of name literals and use of the
 * VALIDVARNAME=ANY option.     
 *---------------------------------------------------------------------*/
  /* *start* */

* RENAME
  R0000100 = 'CASEID_1979'n
  R0153000 = 'ROTTER-1A_1979'n
  R0153100 = 'ROTTER-1B_1979'n
  R0153200 = 'ROTTER-2A_1979'n
  R0153300 = 'ROTTER-2B_1979'n
  R0153400 = 'ROTTER-3A_1979'n
  R0153500 = 'ROTTER-3B_1979'n
  R0153600 = 'ROTTER-4A_1979'n
  R0153700 = 'ROTTER-4B_1979'n
  R0153710 = 'ROTTER_SCORE_1979'n
  R0173600 = 'SAMPLE_ID_1979'n
  R0214700 = 'SAMPLE_RACE_1979'n
  R0214800 = 'SAMPLE_SEX_1979'n
  R0303500 = 'ROSENBERG_ESTEEM_000001_1980'n
  R0303600 = 'ROSENBERG_ESTEEM_000002_1980'n
  R0303700 = 'ROSENBERG_ESTEEM_000003_1980'n
  R0303800 = 'ROSENBERG_ESTEEM_000004_1980'n
  R0303900 = 'ROSENBERG_ESTEEM_000005_1980'n
  R0304000 = 'ROSENBERG_ESTEEM_000006_1980'n
  R0304100 = 'ROSENBERG_ESTEEM_000007_1980'n
  R0304200 = 'ROSENBERG_ESTEEM_000008_1980'n
  R0304300 = 'ROSENBERG_ESTEEM_000009_1980'n
  R0304400 = 'ROSENBERG_ESTEEM_000010_1980'n
  R0304410 = 'ROSENBERG_SCORE_1980'n
  R2349100 = 'ROSENBERG_ESTEEM_000001_1987'n
  R2349200 = 'ROSENBERG_ESTEEM_000002_1987'n
  R2349300 = 'ROSENBERG_ESTEEM_000003_1987'n
  R2349400 = 'ROSENBERG_ESTEEM_000011_1987'n
  R2349500 = 'ROSENBERG_ESTEEM_000012_1987'n
  R2349600 = 'ROSENBERG_ESTEEM_000006_1987'n
  R2349700 = 'ROSENBERG_ESTEEM_000007_1987'n
  R2349800 = 'ROSENBERG_ESTEEM_000008_1987'n
  R2349900 = 'ROSENBERG_ESTEEM_000009_1987'n
  R2350000 = 'ROSENBERG_ESTEEM_000010_1987'n
  R2350010 = 'ROSENBERG_ESTEEM_SCORE_1987'n
  T0899810 = 'ROSENBERG_ESTEEM_SCORE_2006'n
;
  /* *finish* */

run;

proc means data=new_data n mean min max;
run;


/*---------------------------------------------------------------------*
 *  FORMATTED TABULATIONS                                              *
 *---------------------------------------------------------------------*
 * You can uncomment and edit the PROC FORMAT and PROC FREQ statements 
 * provided below to obtain formatted tabulations. The tabulations 
 * should reflect codebook values.
 * 
 * Please edit the formats below reflect any renaming of the variables
 * you may have done in the first data step. 
 *---------------------------------------------------------------------*/

/*
proc format; 
value vx1f
  1='IN CONTROL'
  2='NOT IN CONTROL'
;
value vx2f
  1='MUCH CLOSER'
  2='SLIGHTLY CLOSER'
;
value vx3f
  1='R''S PLANS WORK'
  2='MATTER OF LUCK'
;
value vx4f
  1='MUCH CLOSER'
  2='SLIGHTLY CLOSER'
;
value vx5f
  1='LUCK NOT FACTOR'
  2='FLIP A COIN'
;
value vx6f
  1='MUCH CLOSER'
  2='SLIGHTLY CLOSER'
;
value vx7f
  1='LUCK BIG ROLE'
  2='LUCK NO ROLE'
;
value vx8f
  1='MUCH CLOSER'
  2='SLIGHTLY CLOSER'
;
value vx9f
  0='0'
  1-4='1 TO 4'
  5-9='5 TO 9'
  10-14='10 TO 14'
  15-19='15 TO 19'
;
value vx10f
  1='CROSS MALE WHITE'
  2='CROSS MALE WH. POOR'
  3='CROSS MALE BLACK'
  4='CROSS MALE HISPANIC'
  5='CROSS FEMALE WHITE'
  6='CROSS FEMALE WH POOR'
  7='CROSS FEMALE BLACK'
  8='CROSS FEMALE HISPANIC'
  9='SUP MALE WH POOR'
  10='SUP MALE BLACK'
  11='SUP MALE HISPANIC'
  12='SUP FEM WH POOR'
  13='SUP FEMALE BLACK'
  14='SUP FEMALE HISPANIC'
  15='MIL MALE WHITE'
  16='MIL MALE BLACK'
  17='MIL MALE HISPANIC'
  18='MIL FEMALE WHITE'
  19='MIL FEMALE BLACK'
  20='MIL FEMALE HISPANIC'
;
value vx11f
  1='HISPANIC'
  2='BLACK'
  3='NON-BLACK, NON-HISPANIC'
;
value vx12f
  1='MALE'
  2='FEMALE'
;
value vx13f
  1='STRONGLY AGREE'
  2='AGREE'
  3='DISAGREE'
  4='STRONGLY DISAGREE'
;
value vx14f
  1='STRONGLY AGREE'
  2='AGREE'
  3='DISAGREE'
  4='STRONGLY DISAGREE'
;
value vx15f
  1='STRONGLY AGREE'
  2='AGREE'
  3='DISAGREE'
  4='STRONGLY DISAGREE'
;
value vx16f
  1='STRONGLY AGREE'
  2='AGREE'
  3='DISAGREE'
  4='STRONGLY DISAGREE'
;
value vx17f
  1='STRONGLY AGREE'
  2='AGREE'
  3='DISAGREE'
  4='STRONGLY DISAGREE'
;
value vx18f
  1='STRONGLY AGREE'
  2='AGREE'
  3='DISAGREE'
  4='STRONGLY DISAGREE'
;
value vx19f
  1='STRONGLY AGREE'
  2='AGREE'
  3='DISAGREE'
  4='STRONGLY DISAGREE'
;
value vx20f
  1='STRONGLY AGREE'
  2='AGREE'
  3='DISAGREE'
  4='STRONGLY DISAGREE'
;
value vx21f
  1='STRONGLY AGREE'
  2='AGREE'
  3='DISAGREE'
  4='STRONGLY DISAGREE'
;
value vx22f
  1='STRONGLY AGREE'
  2='AGREE'
  3='DISAGREE'
  4='STRONGLY DISAGREE'
;
value vx23f
  0='0'
  1-4='1 TO 4'
  5-9='5 TO 9'
  10-14='10 TO 14'
  15-19='15 TO 19'
  20-24='20 TO 24'
  25-29='25 TO 29'
  30-34='30 TO 34'
;
value vx24f
  1='STRONGLY AGREE'
  2='AGREE'
  3='DISAGREE'
  4='STRONGLY DISAGREE'
;
value vx25f
  1='STRONGLY AGREE'
  2='AGREE'
  3='DISAGREE'
  4='STRONGLY DISAGREE'
;
value vx26f
  1='STRONGLY AGREE'
  2='AGREE'
  3='DISAGREE'
  4='STRONGLY DISAGREE'
;
value vx27f
  1='STRONGLY AGREE'
  2='AGREE'
  3='DISAGREE'
  4='STRONGLY DISAGREE'
;
value vx28f
  1='STRONGLY AGREE'
  2='AGREE'
  3='DISAGREE'
  4='STRONGLY DISAGREE'
;
value vx29f
  1='STRONGLY AGREE'
  2='AGREE'
  3='DISAGREE'
  4='STRONGLY DISAGREE'
;
value vx30f
  1='STRONGLY AGREE'
  2='AGREE'
  3='DISAGREE'
  4='STRONGLY DISAGREE'
;
value vx31f
  1='STRONGLY AGREE'
  2='AGREE'
  3='DISAGREE'
  4='STRONGLY DISAGREE'
;
value vx32f
  1='STRONGLY AGREE'
  2='AGREE'
  3='DISAGREE'
  4='STRONGLY DISAGREE'
;
value vx33f
  1='STRONGLY AGREE'
  2='AGREE'
  3='DISAGREE'
  4='STRONGLY DISAGREE'
;
value vx34f
  0='0'
  1-4='1 TO 4'
  5-9='5 TO 9'
  10-14='10 TO 14'
  15-19='15 TO 19'
  20-24='20 TO 24'
  25-29='25 TO 29'
  30-34='30 TO 34'
;
value vx35f
  0='0'
  1-4='1 TO 4'
  5-9='5 TO 9'
  10-14='10 TO 14'
  15-19='15 TO 19'
  20-24='20 TO 24'
  25-29='25 TO 29'
  30-34='30 TO 34'
;
*/

/* 
 *--- Tabulations using reference number variables;
proc freq data=new_data;
tables _ALL_ /MISSING;
  format R0153000 vx1f.;
  format R0153100 vx2f.;
  format R0153200 vx3f.;
  format R0153300 vx4f.;
  format R0153400 vx5f.;
  format R0153500 vx6f.;
  format R0153600 vx7f.;
  format R0153700 vx8f.;
  format R0153710 vx9f.;
  format R0173600 vx10f.;
  format R0214700 vx11f.;
  format R0214800 vx12f.;
  format R0303500 vx13f.;
  format R0303600 vx14f.;
  format R0303700 vx15f.;
  format R0303800 vx16f.;
  format R0303900 vx17f.;
  format R0304000 vx18f.;
  format R0304100 vx19f.;
  format R0304200 vx20f.;
  format R0304300 vx21f.;
  format R0304400 vx22f.;
  format R0304410 vx23f.;
  format R2349100 vx24f.;
  format R2349200 vx25f.;
  format R2349300 vx26f.;
  format R2349400 vx27f.;
  format R2349500 vx28f.;
  format R2349600 vx29f.;
  format R2349700 vx30f.;
  format R2349800 vx31f.;
  format R2349900 vx32f.;
  format R2350000 vx33f.;
  format R2350010 vx34f.;
  format T0899810 vx35f.;
run;
*/

/*
*--- Tabulations using default named variables;
proc freq data=new_data;
tables _ALL_ /MISSING;
  format 'ROTTER-1A_1979'n vx1f.;
  format 'ROTTER-1B_1979'n vx2f.;
  format 'ROTTER-2A_1979'n vx3f.;
  format 'ROTTER-2B_1979'n vx4f.;
  format 'ROTTER-3A_1979'n vx5f.;
  format 'ROTTER-3B_1979'n vx6f.;
  format 'ROTTER-4A_1979'n vx7f.;
  format 'ROTTER-4B_1979'n vx8f.;
  format 'ROTTER_SCORE_1979'n vx9f.;
  format 'SAMPLE_ID_1979'n vx10f.;
  format 'SAMPLE_RACE_1979'n vx11f.;
  format 'SAMPLE_SEX_1979'n vx12f.;
  format 'ROSENBERG_ESTEEM_000001_1980'n vx13f.;
  format 'ROSENBERG_ESTEEM_000002_1980'n vx14f.;
  format 'ROSENBERG_ESTEEM_000003_1980'n vx15f.;
  format 'ROSENBERG_ESTEEM_000004_1980'n vx16f.;
  format 'ROSENBERG_ESTEEM_000005_1980'n vx17f.;
  format 'ROSENBERG_ESTEEM_000006_1980'n vx18f.;
  format 'ROSENBERG_ESTEEM_000007_1980'n vx19f.;
  format 'ROSENBERG_ESTEEM_000008_1980'n vx20f.;
  format 'ROSENBERG_ESTEEM_000009_1980'n vx21f.;
  format 'ROSENBERG_ESTEEM_000010_1980'n vx22f.;
  format 'ROSENBERG_SCORE_1980'n vx23f.;
  format 'ROSENBERG_ESTEEM_000001_1987'n vx24f.;
  format 'ROSENBERG_ESTEEM_000002_1987'n vx25f.;
  format 'ROSENBERG_ESTEEM_000003_1987'n vx26f.;
  format 'ROSENBERG_ESTEEM_000011_1987'n vx27f.;
  format 'ROSENBERG_ESTEEM_000012_1987'n vx28f.;
  format 'ROSENBERG_ESTEEM_000006_1987'n vx29f.;
  format 'ROSENBERG_ESTEEM_000007_1987'n vx30f.;
  format 'ROSENBERG_ESTEEM_000008_1987'n vx31f.;
  format 'ROSENBERG_ESTEEM_000009_1987'n vx32f.;
  format 'ROSENBERG_ESTEEM_000010_1987'n vx33f.;
  format 'ROSENBERG_ESTEEM_SCORE_1987'n vx34f.;
  format 'ROSENBERG_ESTEEM_SCORE_2006'n vx35f.;
run;
*/